# 深度影梭客户端开发文档

### 目的

### 主要功能

| 功能（en）                 | 功能(zh)            | 完成情况 | 备注         |
| ---------------------- | ----------------- | ---- | ---------- |
| System Proxy           | 系统代理              | ✗    |            |
| CHNRoutes              |                   | ✗    | 暂不实现       |
| PAC Configuration      | PAC代理             | ✗    |            |
| Profile Switching      | 切换Profile         | ✗    |            |
| QR Code Scan           | 扫描屏幕上的二维码         | ✗    |            |
| QR Code Generation     | 生成二维码             | ✗    |            |
| Import gui-config.json | 导入gui-config.json | ✗    |            |
| Export gui-config.json | 导出gui-config.json | ✗    |            |
| Shortcuts              | 快捷键               | ✗    |            |
| Check Update           | 检查更新              | ✗    | 下载deb包     |
| Update pac             | 更新PAC文件           | ✗    | 从gfwlist更新 |
|                        | 自定义走代理的一些网址       | ✗    |            |
|                        | 流量监控              | ✗    |            |

1. 系统代理

通过调用[libQtShadowsocks](https://github.com/shadowsocks/libQtShadowsocks)实现。

[libQtShadowsocks](https://github.com/shadowsocks/libQtShadowsocks)是为[shadowsocks-qt5](https://github.com/shadowsocks/shadowsocks-qt5)写的库，主要依赖[botan](https://github.com/randombit/botan)，最大的特点就是依赖少。其作者在[libQtShadowsocks项目介绍和备忘](https://www.librehat.com/libqtshadowsocks-project-introduction-and-memo/)有稍微的介绍。

```c++
// 构建libqtss的控制器
// is_local表示是否是本地客户端
// auto_ban意义不明
Controller(Profile _profile,
               bool is_local,
               bool auto_ban,
               QObject *parent = 0);
```



2. PAC代理

通过调用DDE的DBus服务dde-daemon dbus API:`com.deepin.daemon.Network`切换系统的代理模式实现。

```
inline QDBusPendingReply<> SetProxyMethod(const QString &in0)
inline QDBusPendingReply<> SetProxy(const QString &in0, const QString &in1, const QString &in2)
inline QDBusPendingReply<> SetAutoProxy(const QString &in0)
```

3. 切换Profile

通过停止之前启动的libQtShadowsocks的Controller，重新开一个新的Controller实现。

4. 扫描屏幕上的二维码

参考shadowsocks-qt5的实现。首先获取到屏幕上的图像，然后通过zbar解析二维码。

5. 生成二维码

通过调用qrencode生成图片。

6. 导入/导出gui-config.json

通过使用Qt自带的Json库完成。

7. 快捷键

通过调用Qt自带的库完成，如果不行，可以参考[Linux全局事件监听技术](https://www.jianshu.com/p/80cf81413d31)。

8. 检查更新

通过GitHub提供的RESTful API，获取到最新的发布版本，然后把deb下载到本地，由用户自行安装。

9. 更新PAC文件

通过解析最新的[gfwlist](https://raw.githubusercontent.com/gfwlist/gfwlist/master/gfwlist.txt)，同时混合用户自定义的规则来生成新的PAC文件。

10. 流量监控

当有走代理的流量时，系统托盘图标有些许变化。当有上传的流量时，出现图标蓝色的球；当有下载的流量时，出现红色的球；如果都有，就同时出现。

### 界面设计

主要的Profile由DSimpleListView展示，设置有两套，一套由dtksettingsview展示，另一套通过系统托盘的右键菜单展示。

### 编码实现

自己写的所有类放在cn.net.pikachu空间下

gui-config.json只负责存储profile，其他界面配置存储在`config.conf`中。用一个GuiConfig类负责管理Profile类，其他配置由Settings类负责管理。

界面类统一放在widget文件夹下，辅助类统一放在util文件夹下。

#### 一个简单的文件下载器

下载fwlist和deb需要使用。参考《第一行代码》P365实现。

信号

```
progress(int progress)
success()
failed()
paused()
canceled()
```



